import * as i0 from '@angular/core';
import { Component, Directive, Input, EventEmitter, ContentChildren, Output, ViewChild, NgModule } from '@angular/core';
import * as i6 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i8 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import { map } from 'rxjs/operators';
import * as i1 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from '@angular/material/toolbar';
import { MatToolbarModule } from '@angular/material/toolbar';
import * as i4 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i7 from '@angular/material/table';
import { MatTableModule } from '@angular/material/table';
import * as i9 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import * as i10 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import { trigger, state, style, transition, animate } from '@angular/animations';

class LayoutComponent {
    constructor() { }
    ngOnInit() {
    }
    /** @nocollapse */ static ɵfac = function LayoutComponent_Factory(t) { return new (t || LayoutComponent)(); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: LayoutComponent, selectors: [["lib-layout"]], decls: 2, vars: 0, template: function LayoutComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "p");
            i0.ɵɵtext(1, " layout works! ");
            i0.ɵɵelementEnd();
        } }, encapsulation: 2 });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LayoutComponent, [{
        type: Component,
        args: [{ selector: 'lib-layout', template: `
    <p>
      layout works!
    </p>
  ` }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(LayoutComponent, { className: "LayoutComponent", filePath: "chain/layout.component.ts", lineNumber: 13 }); })();

const _c0$3 = [[["", "controls", ""]]];
const _c1$2 = ["[controls]"];
const _c2$1 = a0 => ({ $implicit: a0 });
function TableContentComponent_mat_toolbar_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-toolbar", 11)(1, "span", 12);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r0.tableLayoutInput == null ? null : ctx_r0.tableLayoutInput.title);
} }
function TableContentComponent_mat_toolbar_1_button_1_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 17);
    i0.ɵɵlistener("click", function TableContentComponent_mat_toolbar_1_button_1_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r2); const ctx_r0 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r0.back()); });
    i0.ɵɵelementStart(1, "mat-icon");
    i0.ɵɵtext(2, "arrow_back");
    i0.ɵɵelementEnd()();
} }
function TableContentComponent_mat_toolbar_1_button_3_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 18);
    i0.ɵɵlistener("click", function TableContentComponent_mat_toolbar_1_button_3_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r3); const ctx_r0 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r0.add()); });
    i0.ɵɵelementStart(1, "mat-icon");
    i0.ɵɵtext(2, "add");
    i0.ɵɵelementEnd()();
} }
function TableContentComponent_mat_toolbar_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-toolbar", 13);
    i0.ɵɵtemplate(1, TableContentComponent_mat_toolbar_1_button_1_Template, 3, 0, "button", 14);
    i0.ɵɵelementContainerStart(2);
    i0.ɵɵtemplate(3, TableContentComponent_mat_toolbar_1_button_3_Template, 3, 0, "button", 15);
    i0.ɵɵelementContainerEnd();
    i0.ɵɵelement(4, "div", 16);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", ctx_r0.hasBackButton);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngIf", !(ctx_r0.tableLayoutInput == null ? null : ctx_r0.tableLayoutInput.disableAddButton) && ctx_r0.hasAddButton);
} }
function TableContentComponent_ng_container_8_th_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "th", 22);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const i_r4 = i0.ɵɵnextContext().index;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" ", ctx_r0.columnNames[i_r4], " ");
} }
function TableContentComponent_ng_container_8_td_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "td", 23);
    i0.ɵɵelementContainer(1, 24);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_7_0;
    const row_r5 = ctx.$implicit;
    const column_r6 = i0.ɵɵnextContext().$implicit;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_7_0 = ctx_r0.rowColumnTemplates.get(column_r6)) == null ? null : tmp_7_0.templateRef)("ngTemplateOutletContext", i0.ɵɵpureFunction1(2, _c2$1, row_r5));
} }
function TableContentComponent_ng_container_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 19);
    i0.ɵɵtemplate(1, TableContentComponent_ng_container_8_th_1_Template, 2, 1, "th", 20)(2, TableContentComponent_ng_container_8_td_2_Template, 2, 4, "td", 21);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r6 = ctx.$implicit;
    i0.ɵɵproperty("matColumnDef", column_r6);
} }
function TableContentComponent_tr_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "tr", 25);
} }
function TableContentComponent_tr_10_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "tr", 26);
    i0.ɵɵlistener("click", function TableContentComponent_tr_10_Template_tr_click_0_listener() { const row_r8 = i0.ɵɵrestoreView(_r7).$implicit; const ctx_r0 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r0.onRowClick(row_r8)); });
    i0.ɵɵelementEnd();
} }
function TableContentComponent_mat_card_11_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-card", 27);
} }
function TableContentComponent_mat_card_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-card", 28)(1, "span");
    i0.ɵɵtext(2, "Die Tabelle hat noch keine Eintr\u00E4ge!");
    i0.ɵɵelementEnd()();
} }
function TableContentComponent_mat_card_13_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-card", 28)(1, "mat-error");
    i0.ɵɵtext(2, " Es ist etwas falsch gelaufen");
    i0.ɵɵelementEnd()();
} }
class TableRowColumnDirective {
    templateRef;
    rowColumn;
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    /** @nocollapse */ static ɵfac = function TableRowColumnDirective_Factory(t) { return new (t || TableRowColumnDirective)(i0.ɵɵdirectiveInject(i0.TemplateRef)); };
    /** @nocollapse */ static ɵdir = /** @pureOrBreakMyCode */ i0.ɵɵdefineDirective({ type: TableRowColumnDirective, selectors: [["ng-template", "rowColumn", ""]], inputs: { rowColumn: "rowColumn" } });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableRowColumnDirective, [{
        type: Directive,
        args: [{ selector: 'ng-template[rowColumn]' }]
    }], () => [{ type: i0.TemplateRef }], { rowColumn: [{
            type: Input
        }] }); })();
class TableContentComponent {
    router;
    activatedRoute;
    location;
    _tableLayoutInput;
    dataSource;
    set tableLayoutInput(tl) {
        this._tableLayoutInput = tl;
    }
    ;
    get tableLayoutInput() {
        return this._tableLayoutInput;
    }
    rowColumnDirectives;
    rowColumnTemplates;
    hasToolbar = true;
    hasSearch = true;
    hasAddButton = true;
    hasBackButton = true;
    hasPaginator = true;
    tableRowClick = new EventEmitter();
    addRoute;
    backRoute;
    paginator;
    sort;
    set matSort(ms) {
        this.sort = ms;
    }
    set matPaginator(ms) {
        this.paginator = ms;
    }
    displayedColumns;
    columnNames;
    constructor(router, activatedRoute, location) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.location = location;
    }
    ngOnInit() {
        if (!this.tableLayoutInput) {
            return;
        }
        this.dataSource = this.tableLayoutInput.dataSource;
        this.dataSource.setPaginator(this.paginator);
        this.dataSource.setSort(this.sort);
        this.tableLayoutInput.columnDef.pipe(map(res => res.map(res => res.columnId))).subscribe(res => {
            this.displayedColumns = res;
        });
        this.tableLayoutInput.columnDef.pipe(map(res => res.map(res => res.columnName))).subscribe(res => {
            this.columnNames = res;
        });
        if (this.tableLayoutInput.addRoute) {
            this.addRoute = this.tableLayoutInput.addRoute;
        }
        if (this.tableLayoutInput.backRoute) {
            this.backRoute = this.tableLayoutInput.backRoute;
        }
    }
    ngAfterContentInit() {
        let columnMap = new Map();
        let refArray = this.rowColumnDirectives.toArray();
        refArray.forEach(val => {
            columnMap.set(val.rowColumn, val);
        });
        this.rowColumnTemplates = columnMap;
    }
    getPageSizeOptions() {
        return [5, 10, 20, 50, 100, 250];
    }
    getDefaultPageSize() {
        const tableFilter = this.dataSource.filterSubject.value;
        if (tableFilter && tableFilter.pager) {
            return tableFilter.pager.pageSize;
        }
        return 250;
    }
    add() {
        if (this.addRoute) {
            if (this.addRoute.queryParams) {
                this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
            }
            else {
                this.router.navigate([this.addRoute.path]);
            }
        }
        else {
            this.router.navigate(['0'], { relativeTo: this.activatedRoute });
        }
    }
    back() {
        if (this.backRoute) {
            if (this.backRoute.queryParams) {
                this.router.navigate([this.backRoute.path], { queryParams: this.backRoute.queryParams });
            }
            else {
                this.router.navigate([this.backRoute.path]);
            }
        }
        else {
            this.location.back();
        }
    }
    onRowClick(row) {
        this.tableRowClick.emit(row);
    }
    reload(filter) {
        filter = { ...this.dataSource.filterSubject.value, ...filter };
        this.dataSource.filterSubject.next(filter);
        return false;
    }
    navigateBack() {
        this.location.back();
    }
    /** @nocollapse */ static ɵfac = function TableContentComponent_Factory(t) { return new (t || TableContentComponent)(i0.ɵɵdirectiveInject(i1.Router), i0.ɵɵdirectiveInject(i1.ActivatedRoute), i0.ɵɵdirectiveInject(i2.Location)); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableContentComponent, selectors: [["base-table-content"]], contentQueries: function TableContentComponent_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuery(dirIndex, TableRowColumnDirective, 4);
        } if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.rowColumnDirectives = _t);
        } }, viewQuery: function TableContentComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuery(MatSort, 7);
            i0.ɵɵviewQuery(MatPaginator, 7);
        } if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.matSort = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.matPaginator = _t.first);
        } }, inputs: { tableLayoutInput: "tableLayoutInput", hasToolbar: "hasToolbar", hasSearch: "hasSearch", hasAddButton: "hasAddButton", hasBackButton: "hasBackButton", hasPaginator: "hasPaginator" }, outputs: { tableRowClick: "tableRowClick" }, ngContentSelectors: _c1$2, decls: 14, vars: 12, consts: [["paginator", ""], ["matTable", ""], ["color", "accent", "style", "height:20px; opacity: 0.5", 4, "ngIf"], ["style", "height:90px", "class", "table-layout-toolbar", 4, "ngIf"], [3, "pageSizeOptions"], ["mat-table", "", "matSort", "", "matSortDisableClear", "", 3, "dataSource", "matSortActive", "matSortDirection"], [3, "matColumnDef", 4, "ngFor", "ngForOf"], ["mat-header-row", "", 4, "matHeaderRowDef"], ["mat-row", "", "class", "row-click", 3, "click", 4, "matRowDef", "matRowDefColumns"], ["fxLayout", "row", "fxLayoutAlign", "center", 4, "ngIf"], ["fxLayoutAlign", "center", 4, "ngIf"], ["color", "accent", 2, "height", "20px", "opacity", "0.5"], [2, "font-size", "0.7em"], [1, "table-layout-toolbar", 2, "height", "90px"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "class", "margin-right--small", 3, "click", 4, "ngIf"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "value", "create", "class", "margin-right--small", 3, "click", 4, "ngIf"], [1, "spacer"], ["mat-mini-fab", "", "name", "cmd", "type", "button", 1, "margin-right--small", 3, "click"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "value", "create", 1, "margin-right--small", 3, "click"], [3, "matColumnDef"], ["mat-sort-header", "", "mat-header-cell", "", 4, "matHeaderCellDef"], ["mat-cell", "", 4, "matCellDef"], ["mat-sort-header", "", "mat-header-cell", ""], ["mat-cell", ""], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], ["mat-header-row", ""], ["mat-row", "", 1, "row-click", 3, "click"], ["fxLayout", "row", "fxLayoutAlign", "center"], ["fxLayoutAlign", "center"]], template: function TableContentComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c0$3);
            i0.ɵɵtemplate(0, TableContentComponent_mat_toolbar_0_Template, 3, 1, "mat-toolbar", 2)(1, TableContentComponent_mat_toolbar_1_Template, 5, 2, "mat-toolbar", 3);
            i0.ɵɵprojection(2);
            i0.ɵɵelementStart(3, "div");
            i0.ɵɵelement(4, "mat-paginator", 4, 0);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(6, "table", 5, 1);
            i0.ɵɵtemplate(8, TableContentComponent_ng_container_8_Template, 3, 1, "ng-container", 6)(9, TableContentComponent_tr_9_Template, 1, 0, "tr", 7)(10, TableContentComponent_tr_10_Template, 1, 0, "tr", 8);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(11, TableContentComponent_mat_card_11_Template, 1, 0, "mat-card", 9)(12, TableContentComponent_mat_card_12_Template, 3, 0, "mat-card", 10)(13, TableContentComponent_mat_card_13_Template, 3, 0, "mat-card", 10);
        } if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.title);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngIf", ctx.hasToolbar);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("pageSizeOptions", ctx.getPageSizeOptions());
            i0.ɵɵadvance(2);
            i0.ɵɵpropertyInterpolate("matSortActive", ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.matSortActive);
            i0.ɵɵpropertyInterpolate("matSortDirection", (ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.matSortDirection) ? ctx.tableLayoutInput.matSortDirection : "desc");
            i0.ɵɵproperty("dataSource", ctx.dataSource);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngForOf", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngIf", (ctx.dataSource == null ? null : ctx.dataSource.status) === "loading");
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngIf", (ctx.dataSource == null ? null : ctx.dataSource.dataSubject == null ? null : ctx.dataSource.dataSubject.value == null ? null : ctx.dataSource.dataSubject.value.length) === 0);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngIf", (ctx.dataSource == null ? null : ctx.dataSource.status) === "error");
        } }, dependencies: [i3.MatToolbar, i4.MatIcon, i5.MatMiniFabButton, i2.NgForOf, i2.NgIf, i2.NgTemplateOutlet, i6.MatPaginator, i7.MatTable, i7.MatHeaderCellDef, i7.MatHeaderRowDef, i7.MatColumnDef, i7.MatCellDef, i7.MatRowDef, i7.MatHeaderCell, i7.MatCell, i7.MatHeaderRow, i7.MatRow, i8.MatSort, i8.MatSortHeader, i9.MatCard, i10.MatError], encapsulation: 2 });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableContentComponent, [{
        type: Component,
        args: [{ selector: 'base-table-content', template: "<mat-toolbar *ngIf=\"tableLayoutInput?.title\" color=\"accent\" style=\"height:20px; opacity: 0.5\"><span\n  style=\"font-size: 0.7em\">{{tableLayoutInput?.title}}</span></mat-toolbar>\n<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" (click)='back()' class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n    <ng-container>   <!-- <ng-container *permissionEdit=\"tableLayoutInput?.expectedRoles\">-->\n        <button *ngIf=\"!tableLayoutInput?.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix this -->\n    <!--  <button *ngIf=\"tableLayoutInput?.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n              (click)=\"dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n        <mat-icon>cloud_download</mat-icon>\n      </button>-->\n\n    <!--  <table-search [searchFields]=\"tableLayoutInput?.advanceSearchCriteria\"\n                    [hasAdvanceSearch]=\"tableLayoutInput?.advanceSearch\" *ngIf=\"tableLayoutInput?.searchable && hasSearch\"\n                    (changed)=\"reload($event)\"\n                    class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<table #matTable mat-table [dataSource]=\"dataSource\" matSort\n       matSortActive=\"{{tableLayoutInput?.matSortActive}}\" matSortDisableClear\n       matSortDirection=\"{{tableLayoutInput?.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\">\n\n  <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n    <th mat-sort-header mat-header-cell *matHeaderCellDef>\n      {{columnNames[i]}}\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                    [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n    </td>\n  </ng-container>\n\n  <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\" class=\"row-click\"></tr>\n</table>\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"dataSource?.status === 'loading'\" fxLayoutAlign=\"center\">\n  <!-- TODO extract loading indicator component to library <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n<!-- ===================================== Table empty ============================================================= -->\n<mat-card *ngIf=\"dataSource?.dataSubject?.value?.length === 0\" fxLayoutAlign=\"center\">\n  <span><!-- TODO should be configured as input prop -->Die Tabelle hat noch keine Eintr\u00E4ge!</span>\n</mat-card>\n\n<!-- ===================================== Table error ============================================================= -->\n<mat-card *ngIf=\"dataSource?.status === 'error'\" fxLayoutAlign=\"center\">\n  <mat-error><!-- TODO should be configured as input prop --> Es ist etwas falsch gelaufen</mat-error>\n</mat-card>\n" }]
    }], () => [{ type: i1.Router }, { type: i1.ActivatedRoute }, { type: i2.Location }], { tableLayoutInput: [{
            type: Input
        }], rowColumnDirectives: [{
            type: ContentChildren,
            args: [TableRowColumnDirective]
        }], hasToolbar: [{
            type: Input
        }], hasSearch: [{
            type: Input
        }], hasAddButton: [{
            type: Input
        }], hasBackButton: [{
            type: Input
        }], hasPaginator: [{
            type: Input
        }], tableRowClick: [{
            type: Output
        }], matSort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }], matPaginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TableContentComponent, { className: "TableContentComponent", filePath: "chain/base/comp/layout/table/table-content/table-content.component.ts", lineNumber: 41 }); })();

class TableTitleComponent {
    constructor() { }
    ngOnInit() {
    }
    /** @nocollapse */ static ɵfac = function TableTitleComponent_Factory(t) { return new (t || TableTitleComponent)(); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableTitleComponent, selectors: [["app-table-title"]], decls: 2, vars: 0, template: function TableTitleComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "p");
            i0.ɵɵtext(1, " table-title works!\n");
            i0.ɵɵelementEnd();
        } }, encapsulation: 2 });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableTitleComponent, [{
        type: Component,
        args: [{ selector: 'app-table-title', template: "<p>\n  table-title works!\n</p>\n" }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TableTitleComponent, { className: "TableTitleComponent", filePath: "chain/base/comp/layout/table/table-title/table-title.component.ts", lineNumber: 7 }); })();

const _c0$2 = ["*"];
class TableHeaderComponent {
    constructor() { }
    ngOnInit() {
    }
    /** @nocollapse */ static ɵfac = function TableHeaderComponent_Factory(t) { return new (t || TableHeaderComponent)(); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableHeaderComponent, selectors: [["base-table-header"]], ngContentSelectors: _c0$2, decls: 3, vars: 0, consts: [["fxLayoutGap", "10px"], [1, "spacer"]], template: function TableHeaderComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "mat-toolbar", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelement(2, "div", 1);
            i0.ɵɵelementEnd();
        } }, dependencies: [i3.MatToolbar], encapsulation: 2 });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableHeaderComponent, [{
        type: Component,
        args: [{ selector: 'base-table-header', template: "<mat-toolbar fxLayoutGap=\"10px\">\n  <ng-content></ng-content>\n  <div class=\"spacer\"></div>\n</mat-toolbar>\n" }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TableHeaderComponent, { className: "TableHeaderComponent", filePath: "chain/base/comp/layout/table/table-header/table-header.component.ts", lineNumber: 7 }); })();

const _c0$1 = [[["", "content", ""]]];
const _c1$1 = ["[content]"];
class TableLayoutComponent {
    status = 'loading';
    constructor() { }
    ngOnInit() {
    }
    /** @nocollapse */ static ɵfac = function TableLayoutComponent_Factory(t) { return new (t || TableLayoutComponent)(); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableLayoutComponent, selectors: [["base-table-layout"]], inputs: { status: "status" }, ngContentSelectors: _c1$1, decls: 2, vars: 0, consts: [[1, "table-layout", "mat-elevation-z12"]], template: function TableLayoutComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c0$1);
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelementEnd();
        } }, encapsulation: 2 });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableLayoutComponent, [{
        type: Component,
        args: [{ selector: 'base-table-layout', template: "<div class=\"table-layout mat-elevation-z12\">\n  <ng-content select=\"[content]\"></ng-content>\n</div>\n" }]
    }], () => [], { status: [{
            type: Input
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TableLayoutComponent, { className: "TableLayoutComponent", filePath: "chain/base/comp/layout/table/table-layout/table-layout.component.ts", lineNumber: 7 }); })();

const _c0 = [[["", "controls", ""]]];
const _c1 = ["[controls]"];
const _c2 = a0 => ({ $implicit: a0 });
function TableContentResponsiveComponent_mat_toolbar_0_button_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "button", 13)(1, "mat-icon");
    i0.ɵɵtext(2, "arrow_back");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    i0.ɵɵproperty("routerLink", "..");
} }
function TableContentResponsiveComponent_mat_toolbar_0_button_3_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 14);
    i0.ɵɵlistener("click", function TableContentResponsiveComponent_mat_toolbar_0_button_3_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.add()); });
    i0.ɵɵelementStart(1, "mat-icon");
    i0.ɵɵtext(2, "add");
    i0.ɵɵelementEnd()();
} }
function TableContentResponsiveComponent_mat_toolbar_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-toolbar", 9);
    i0.ɵɵtemplate(1, TableContentResponsiveComponent_mat_toolbar_0_button_1_Template, 3, 1, "button", 10);
    i0.ɵɵelementContainerStart(2);
    i0.ɵɵtemplate(3, TableContentResponsiveComponent_mat_toolbar_0_button_3_Template, 3, 0, "button", 11);
    i0.ɵɵelementContainerEnd();
    i0.ɵɵelement(4, "div", 12);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", ctx_r1.hasBackButton);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngIf", !(ctx_r1.tableLayoutInput == null ? null : ctx_r1.tableLayoutInput.disableAddButton) && ctx_r1.hasAddButton);
} }
function TableContentResponsiveComponent_ng_container_7_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 18);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const i_r3 = i0.ɵɵnextContext().index;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" ", ctx_r1.columnNames[i_r3], " ");
} }
function TableContentResponsiveComponent_ng_container_7_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell")(1, "span", 19);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementContainer(3, 20);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_7_0;
    const row_r4 = ctx.$implicit;
    const ctx_r4 = i0.ɵɵnextContext();
    const column_r6 = ctx_r4.$implicit;
    const i_r3 = ctx_r4.index;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r1.columnNames[i_r3]);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_7_0 = ctx_r1.rowColumnTemplates.get(column_r6)) == null ? null : tmp_7_0.templateRef)("ngTemplateOutletContext", i0.ɵɵpureFunction1(3, _c2, row_r4));
} }
function TableContentResponsiveComponent_ng_container_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 15);
    i0.ɵɵtemplate(1, TableContentResponsiveComponent_ng_container_7_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 16)(2, TableContentResponsiveComponent_ng_container_7_mat_cell_2_Template, 4, 5, "mat-cell", 17);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r6 = ctx.$implicit;
    i0.ɵɵproperty("matColumnDef", column_r6);
} }
function TableContentResponsiveComponent_mat_header_row_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-row");
} }
function TableContentResponsiveComponent_mat_row_9_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-row", 21);
    i0.ɵɵlistener("click", function TableContentResponsiveComponent_mat_row_9_Template_mat_row_click_0_listener() { const row_r8 = i0.ɵɵrestoreView(_r7).$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onRowClick(row_r8)); });
    i0.ɵɵelementEnd();
} }
function TableContentResponsiveComponent_mat_card_10_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-card", 22);
} }
class TableContentResponsiveComponent {
    router;
    activatedRoute;
    location;
    _tableLayoutInput;
    expandedElement;
    set tableLayoutInput(tl) {
        this._tableLayoutInput = tl;
    }
    get tableLayoutInput() {
        return this._tableLayoutInput;
    }
    rowColumnDirectives;
    rowColumnTemplates;
    hasToolbar = true;
    hasSearch = true;
    hasAddButton = true;
    hasBackButton = true;
    hasPaginator = true;
    tableRowClick = new EventEmitter();
    addRoute;
    paginator;
    sort;
    set matSort(ms) {
        this.sort = ms;
    }
    set matPaginator(ms) {
        this.paginator = ms;
    }
    displayedColumns;
    columnNames;
    constructor(router, activatedRoute, location) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.location = location;
    }
    ngOnInit() {
        if (!this.tableLayoutInput) {
            return;
        }
        this.tableLayoutInput.dataSource.setPaginator(this.paginator);
        this.tableLayoutInput.dataSource.setSort(this.sort);
        this.tableLayoutInput.columnDef.pipe(map(res => res.map(res => res.columnId))).subscribe(res => {
            this.displayedColumns = res;
        });
        this.tableLayoutInput.columnDef.pipe(map(res => res.map(res => res.columnName))).subscribe(res => {
            this.columnNames = res;
        });
        if (this.tableLayoutInput.addRoute) {
            this.addRoute = this.tableLayoutInput.addRoute;
        }
    }
    ngAfterContentInit() {
        const columnMap = new Map();
        const refArray = this.rowColumnDirectives.toArray();
        refArray.forEach(val => {
            columnMap.set(val.rowColumn, val);
        });
        this.rowColumnTemplates = columnMap;
    }
    getPageSizeOptions() {
        return [5, 10, 20, 50, 100, 250];
    }
    getDefaultPageSize() {
        return 250;
    }
    add() {
        if (this.addRoute) {
            if (this.addRoute.queryParams) {
                this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
            }
            else {
                this.router.navigate([this.addRoute.path]);
            }
        }
        else {
            this.router.navigate(['0'], { relativeTo: this.activatedRoute });
        }
    }
    onRowClick(row) {
        this.tableRowClick.emit(row);
    }
    reload(filter) {
        this.tableLayoutInput.dataSource.filterSubject.next(filter);
        return false;
    }
    navigateBack() {
        this.location.back();
    }
    /** @nocollapse */ static ɵfac = function TableContentResponsiveComponent_Factory(t) { return new (t || TableContentResponsiveComponent)(i0.ɵɵdirectiveInject(i1.Router), i0.ɵɵdirectiveInject(i1.ActivatedRoute), i0.ɵɵdirectiveInject(i2.Location)); };
    /** @nocollapse */ static ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableContentResponsiveComponent, selectors: [["base-table-content-responsive"]], contentQueries: function TableContentResponsiveComponent_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuery(dirIndex, TableRowColumnDirective, 4);
        } if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.rowColumnDirectives = _t);
        } }, viewQuery: function TableContentResponsiveComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuery(MatSort, 7);
            i0.ɵɵviewQuery(MatPaginator, 7);
        } if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.matSort = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.matPaginator = _t.first);
        } }, inputs: { tableLayoutInput: "tableLayoutInput", hasToolbar: "hasToolbar", hasSearch: "hasSearch", hasAddButton: "hasAddButton", hasBackButton: "hasBackButton", hasPaginator: "hasPaginator" }, outputs: { tableRowClick: "tableRowClick" }, ngContentSelectors: _c1, decls: 11, vars: 11, consts: [["paginator", ""], ["style", "height:90px", "class", "table-layout-toolbar", 4, "ngIf"], [3, "pageIndex", "pageSize", "pageSizeOptions"], [1, "base-table-responsive"], ["multiTemplateDataRows", "", "matSort", "", "matSortDisableClear", "", 1, "expandable", 3, "dataSource", "matSortActive", "matSortDirection"], [3, "matColumnDef", 4, "ngFor", "ngForOf"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["fxLayout", "row", "fxLayoutAlign", "center", 4, "ngIf"], [1, "table-layout-toolbar", 2, "height", "90px"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "class", "margin-right--small", 3, "routerLink", 4, "ngIf"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "value", "create", "class", "margin-right--small", 3, "click", 4, "ngIf"], [1, "spacer"], ["mat-mini-fab", "", "name", "cmd", "type", "button", 1, "margin-right--small", 3, "routerLink"], ["mat-mini-fab", "", "name", "cmd", "type", "button", "value", "create", 1, "margin-right--small", 3, "click"], [3, "matColumnDef"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["mat-sort-header", ""], [1, "resp-row-label", 2, "float", "left", "padding", "0"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], [3, "click"], ["fxLayout", "row", "fxLayoutAlign", "center"]], template: function TableContentResponsiveComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c0);
            i0.ɵɵtemplate(0, TableContentResponsiveComponent_mat_toolbar_0_Template, 5, 2, "mat-toolbar", 1);
            i0.ɵɵprojection(1);
            i0.ɵɵelementStart(2, "div");
            i0.ɵɵelement(3, "mat-paginator", 2, 0);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(5, "div", 3)(6, "mat-table", 4);
            i0.ɵɵtemplate(7, TableContentResponsiveComponent_ng_container_7_Template, 3, 1, "ng-container", 5)(8, TableContentResponsiveComponent_mat_header_row_8_Template, 1, 0, "mat-header-row", 6)(9, TableContentResponsiveComponent_mat_row_9_Template, 1, 0, "mat-row", 7);
            i0.ɵɵelementEnd()();
            i0.ɵɵtemplate(10, TableContentResponsiveComponent_mat_card_10_Template, 1, 0, "mat-card", 8);
        } if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.hasToolbar);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("pageIndex", 0)("pageSize", ctx.getDefaultPageSize())("pageSizeOptions", ctx.getPageSizeOptions());
            i0.ɵɵadvance(3);
            i0.ɵɵpropertyInterpolate("matSortActive", ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.matSortActive);
            i0.ɵɵpropertyInterpolate("matSortDirection", (ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.matSortDirection) ? ctx.tableLayoutInput.matSortDirection : "desc");
            i0.ɵɵproperty("dataSource", ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.dataSource);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngForOf", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngIf", (ctx.tableLayoutInput == null ? null : ctx.tableLayoutInput.dataSource.status) === "loading");
        } }, dependencies: [i3.MatToolbar, i4.MatIcon, i5.MatMiniFabButton, i2.NgForOf, i2.NgIf, i2.NgTemplateOutlet, i6.MatPaginator, i7.MatTable, i7.MatHeaderCellDef, i7.MatHeaderRowDef, i7.MatColumnDef, i7.MatCellDef, i7.MatRowDef, i7.MatHeaderCell, i7.MatCell, i7.MatHeaderRow, i7.MatRow, i8.MatSort, i8.MatSortHeader, i9.MatCard, i1.RouterLink], encapsulation: 2, data: { animation: [
                trigger('detailExpand', [
                    state('collapsed', style({ height: '0px', minHeight: '0', display: 'none' })),
                    state('expanded', style({ height: '*' })),
                    transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                ]),
            ] } });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableContentResponsiveComponent, [{
        type: Component,
        args: [{ selector: 'base-table-content-responsive', animations: [
                    trigger('detailExpand', [
                        state('collapsed', style({ height: '0px', minHeight: '0', display: 'none' })),
                        state('expanded', style({ height: '*' })),
                        transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                    ]),
                ], template: "<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" [routerLink]=\"'..'\" class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n    <ng-container><!-- <ng-container *permissionEdit=\"tableLayoutInput?.expectedRoles\">-->\n        <button *ngIf=\"!tableLayoutInput?.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix the excel export; probably those controls should be injectable via template/ngcontent -->\n    <!--  <button *ngIf=\"tableLayoutInput?.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n              (click)=\"tableLayoutInput?.dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n        <mat-icon>cloud_download</mat-icon>\n      </button>-->\n\n    <!--  <table-search [searchFields]=\"tableLayoutInput?.advanceSearchCriteria\"\n                    [hasAdvanceSearch]=\"tableLayoutInput?.advanceSearch\" *ngIf=\"tableLayoutInput?.searchable && hasSearch\"\n                    (changed)=\"reload($event)\"\n                    class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"getDefaultPageSize()\" [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<div class=\"base-table-responsive\">\n    <mat-table multiTemplateDataRows [dataSource]=\"tableLayoutInput?.dataSource\" matSort\n               matSortActive=\"{{tableLayoutInput?.matSortActive}}\" matSortDisableClear\n               matSortDirection=\"{{tableLayoutInput?.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\"\n             class=\"expandable\">\n\n    <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n\n      <mat-header-cell *matHeaderCellDef mat-sort-header>\n        {{columnNames[i]}}\n      </mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span class=\"resp-row-label\" style=\"float:left; padding:0;\">{{columnNames[i]}}</span>\n        <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                      [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n      </mat-cell>\n\n    </ng-container>\n\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\">\n    </mat-row>\n\n  </mat-table>\n</div>\n\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"tableLayoutInput?.dataSource.status === 'loading'\" fxLayoutAlign=\"center\">\n<!-- TODO put loading indicator here  <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n\n\n" }]
    }], () => [{ type: i1.Router }, { type: i1.ActivatedRoute }, { type: i2.Location }], { tableLayoutInput: [{
            type: Input
        }], rowColumnDirectives: [{
            type: ContentChildren,
            args: [TableRowColumnDirective]
        }], hasToolbar: [{
            type: Input
        }], hasSearch: [{
            type: Input
        }], hasAddButton: [{
            type: Input
        }], hasBackButton: [{
            type: Input
        }], hasPaginator: [{
            type: Input
        }], tableRowClick: [{
            type: Output
        }], matSort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }], matPaginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TableContentResponsiveComponent, { className: "TableContentResponsiveComponent", filePath: "chain/base/comp/layout/table/table-content-responsive/table-content-responsive.component.ts", lineNumber: 30 }); })();

class TableLayoutModule {
    /** @nocollapse */ static ɵfac = function TableLayoutModule_Factory(t) { return new (t || TableLayoutModule)(); };
    /** @nocollapse */ static ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: TableLayoutModule });
    /** @nocollapse */ static ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [MatToolbarModule,
            MatIconModule,
            MatButtonModule,
            CommonModule,
            MatPaginatorModule,
            MatTableModule,
            MatSortModule,
            MatCardModule,
            MatFormFieldModule,
            RouterModule] });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableLayoutModule, [{
        type: NgModule,
        args: [{
                declarations: [
                    TableRowColumnDirective,
                    TableContentComponent,
                    TableTitleComponent,
                    TableHeaderComponent,
                    TableLayoutComponent,
                    TableContentResponsiveComponent
                ],
                imports: [
                    MatToolbarModule,
                    MatIconModule,
                    MatButtonModule,
                    CommonModule,
                    MatPaginatorModule,
                    MatTableModule,
                    MatSortModule,
                    MatCardModule,
                    MatFormFieldModule,
                    RouterModule,
                ],
                exports: [
                    TableRowColumnDirective,
                    TableContentComponent,
                    TableTitleComponent,
                    TableHeaderComponent,
                    TableLayoutComponent,
                    TableContentResponsiveComponent
                ]
            }]
    }], null, null); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(TableLayoutModule, { declarations: [TableRowColumnDirective,
        TableContentComponent,
        TableTitleComponent,
        TableHeaderComponent,
        TableLayoutComponent,
        TableContentResponsiveComponent], imports: [MatToolbarModule,
        MatIconModule,
        MatButtonModule,
        CommonModule,
        MatPaginatorModule,
        MatTableModule,
        MatSortModule,
        MatCardModule,
        MatFormFieldModule,
        RouterModule], exports: [TableRowColumnDirective,
        TableContentComponent,
        TableTitleComponent,
        TableHeaderComponent,
        TableLayoutComponent,
        TableContentResponsiveComponent] }); })();

class LayoutModule {
    /** @nocollapse */ static ɵfac = function LayoutModule_Factory(t) { return new (t || LayoutModule)(); };
    /** @nocollapse */ static ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: LayoutModule });
    /** @nocollapse */ static ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [TableLayoutModule, TableLayoutModule] });
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LayoutModule, [{
        type: NgModule,
        args: [{
                declarations: [LayoutComponent],
                imports: [
                    TableLayoutModule
                ],
                exports: [
                    TableLayoutModule
                ]
            }]
    }], null, null); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(LayoutModule, { declarations: [LayoutComponent], imports: [TableLayoutModule], exports: [TableLayoutModule] }); })();

/*
 * Public API Surface of layout
 */

/**
 * Generated bundle index. Do not edit.
 */

export { LayoutModule, TableContentComponent, TableContentResponsiveComponent, TableHeaderComponent, TableLayoutComponent, TableLayoutModule, TableRowColumnDirective, TableTitleComponent };
//# sourceMappingURL=yukawa-chain-base-angular-layout.mjs.map
